%------------------------------------------------------------------------
% Function to define the GGCM model for CRF estimation
%------------------------------------------------------------------------
function Y = crf_ggcm(X, coeffs)
coeffs    = coeffs(:);
numcoeffs = numel(coeffs);
if numcoeffs == 1
    c1  = coeffs(1);
    Xpow= 1./(c1);
elseif numcoeffs == 2
    c1  = coeffs(1);
    c2  = coeffs(2);
    Xpow= 1./(c1 + c2.*X);
elseif numcoeffs == 3
    c1  = coeffs(1);
    c2  = coeffs(2);
    c3  = coeffs(3);
    Xpow= 1./(c1 + c2.*X + c3.*X.^2);
else
    error('GGCM model with coeffs>3 Not implemented yet!');
end
Y   = X.^Xpow;