%------------------------------------------------------------------------
% Function to define the Polynomial model for CRF estimation
%------------------------------------------------------------------------
function Y = crf_poly(X, coeffs)
coeffs    = coeffs(:);
numcoeffs = numel(coeffs);
if numcoeffs == 1
    c1  = coeffs(1);
    Y   = X + c1.*(1-X).*(X);
elseif numcoeffs == 2
    c1  = coeffs(1);
    c2  = coeffs(2);
    Y   = X + c2.*(1-X).*(X) + c1.*(1-X).*(X.^2);
elseif numcoeffs == 3
    c1  = coeffs(1);
    c2  = coeffs(2);
    c3  = coeffs(3);
    Y   = X + c3.*(1-X).*(X) + c2.*(1-X).*(X.^2) + ...
              c1.*(1-X).*(X.^3);
elseif numcoeffs == 4
    c1  = coeffs(1);
    c2  = coeffs(2);
    c3  = coeffs(3);
    c4  = coeffs(4);
    Y   = X + c4.*(1-X).*(X) + c3.*(1-X).*(X.^2) + ...
              c2.*(1-X).*(X.^3) + c1.*(1-X).*(X.^4);
else
    error('Poly model with more coeefs Not implemented yet!');
end
