% This code requires parallel computing toobox for parallel estimation from the patches
% If seqential estimation is done, the process is too slow!!

clearvars;
close all;
warning('off','all')
warning

% Add libraries
addpath(genpath('./helpers/'));

% Read the image
imgname = 'sample.png';
rgb  = im2double(imread(imgname));

% Extract non-uniform/edge patches
patchSize        = 21;
patchHalfSize = floor(patchSize./2);
varThrUniformity  = (25/255)^2;
varThrDistribution= (20/255)^2;
fprintf('Estimating patches ...\n'); tic;
[patchCenterCoords, patchScanDirn] = getPatches(rgb, patchSize, ...
                                                                                          varThrUniformity, ...
                                                                                          varThrDistribution);

patchCenterCoords = patchCenterCoords';
patchScanDirn         = patchScanDirn';
numPatches             = numel(patchCenterCoords);
fprintf('Estimated %d patches in %.2f mins ...\n', numPatches, toc/60);

% Perform stage-wise CRF prediction
params.min_prom_minima = 0;
params.filter_linear_values = 0;
params.patch_skip_freq      = 2;
params.imgname = imgname;
params.numPatches  = numPatches;
params.patchSize       = patchSize;
params.patchHalfSize=patchHalfSize;
params.gamma_pred_model        = 'GGCM';
params.gamma_pred_numcoeffs = 2;
params.lambda_wt_init  = 0.3;
resultsCRF = estimateCRFfromPatches(params, rgb, patchCenterCoords, patchScanDirn);

% Display the results
figure(1), plot(resultsCRF.trueI, resultsCRF.predCRFfinal, 'b-', 'Linewidth', 2), 
grid on, grid minor; %saveas(gcf, [imgname(1:end-4), '_crf.png']);
